Index: src/Actions/SelectionAction/AtomByIdAction.hpp
===================================================================
--- src/Actions/SelectionAction/AtomByIdAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/SelectionAction/AtomByIdAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,28 +11,6 @@
 #include "Actions/Action.hpp"
 
-class atom;
-
-void SelectionAtomById(atom *_atom);
-
-class SelectionAtomByIdAction : public Action {
-  friend void SelectionAtomById(atom *_atom);
-
-public:
-  SelectionAtomByIdAction();
-  virtual ~SelectionAtomByIdAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "AtomByIdAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* ATOMBYIDACTION_HPP_ */
Index: src/Actions/SelectionAction/ClearAllAtomsAction.cpp
===================================================================
--- src/Actions/SelectionAction/ClearAllAtomsAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/ClearAllAtomsAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,78 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * ClearAllAtomsAction.cpp
+ *
+ *  Created on: Aug 09, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Descriptors/AtomDescriptor.hpp"
+#include "atom.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "Actions/SelectionAction/ClearAllAtomsAction.hpp"
+
+// and construct the stuff
+#include "ClearAllAtomsAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionClearAllAtomsAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
+
+  std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
+  DoLog(1) && (Log() << Verbose(1) << "Clearing atoms selection." << endl);
+  World::getInstance().clearAtomSelection();
+  return Action::state_ptr(new SelectionClearAllAtomsState(selectedAtoms, params));
+}
+
+Action::state_ptr SelectionClearAllAtomsAction::performUndo(Action::state_ptr _state) {
+  SelectionClearAllAtomsState *state = assert_cast<SelectionClearAllAtomsState*>(_state.get());
+
+  World::getInstance().clearAtomSelection();
+  for(std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter)
+    World::getInstance().selectAtom(*iter);
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr SelectionClearAllAtomsAction::performRedo(Action::state_ptr _state){
+  //SelectionClearAllAtomsState *state = assert_cast<SelectionClearAllAtomsState*>(_state.get());
+
+  World::getInstance().clearAtomSelection();
+
+  return Action::state_ptr(_state);
+}
+
+bool SelectionClearAllAtomsAction::canUndo() {
+  return true;
+}
+
+bool SelectionClearAllAtomsAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionClearAllAtomsAction::getName() {
+  return NAME;
+}
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/ClearAllAtomsAction.def
===================================================================
--- src/Actions/SelectionAction/ClearAllAtomsAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/ClearAllAtomsAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,24 @@
+/*
+ * ClearAllAtomsAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME ClearAllAtoms
+#define TOKEN "clear-atom-selection"
+
Index: src/Actions/SelectionAction/ClearAllAtomsAction.hpp
===================================================================
--- src/Actions/SelectionAction/ClearAllAtomsAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/ClearAllAtomsAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,16 @@
+/*
+ * ClearAllAtomsAction.hpp
+ *
+ *  Created on: Aug 09, 2010
+ *      Author: heber
+ */
+
+#ifndef CLEARALLATOMSACTION_HPP_
+#define CLEARALLATOMSACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+#include "ClearAllAtomsAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* CLEARALLATOMSACTION_HPP_ */
Index: src/Actions/SelectionAction/ClearAllMoleculesAction.cpp
===================================================================
--- src/Actions/SelectionAction/ClearAllMoleculesAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/ClearAllMoleculesAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,78 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * ClearAllMoleculesAction.cpp
+ *
+ *  Created on: Aug 09, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Descriptors/MoleculeDescriptor.hpp"
+#include "atom.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "Actions/SelectionAction/ClearAllMoleculesAction.hpp"
+
+// and construct the stuff
+#include "ClearAllMoleculesAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionClearAllMoleculesAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
+
+  std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
+  DoLog(1) && (Log() << Verbose(1) << "Clearing molecule selection." << endl);
+  World::getInstance().clearMoleculeSelection();
+  return Action::state_ptr(new SelectionClearAllMoleculesState(selectedMolecules,params));
+}
+
+Action::state_ptr SelectionClearAllMoleculesAction::performUndo(Action::state_ptr _state) {
+  SelectionClearAllMoleculesState *state = assert_cast<SelectionClearAllMoleculesState*>(_state.get());
+
+  World::getInstance().clearMoleculeSelection();
+  for(std::vector<molecule *>::iterator iter = state->selectedMolecules.begin(); iter != state->selectedMolecules.end(); ++iter)
+    World::getInstance().selectMolecule(*iter);
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr SelectionClearAllMoleculesAction::performRedo(Action::state_ptr _state){
+  //SelectionClearAllMoleculesState *state = assert_cast<SelectionClearAllMoleculesState*>(_state.get());
+
+  World::getInstance().clearMoleculeSelection();
+
+  return Action::state_ptr(_state);
+}
+
+bool SelectionClearAllMoleculesAction::canUndo() {
+  return true;
+}
+
+bool SelectionClearAllMoleculesAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionClearAllMoleculesAction::getName() {
+  return NAME;
+}
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/ClearAllMoleculesAction.def
===================================================================
--- src/Actions/SelectionAction/ClearAllMoleculesAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/ClearAllMoleculesAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,24 @@
+/*
+ * ClearAllMoleculesAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#define statetypes (std::vector<molecule*>)
+#define statereferences (selectedMolecules)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME ClearAllMolecules
+#define TOKEN "clear-molecule-selection"
+
Index: src/Actions/SelectionAction/ClearAllMoleculesAction.hpp
===================================================================
--- src/Actions/SelectionAction/ClearAllMoleculesAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/ClearAllMoleculesAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,16 @@
+/*
+ * ClearAllMoleculesAction.hpp
+ *
+ *  Created on: Aug 09, 2010
+ *      Author: heber
+ */
+
+#ifndef CLEARALLMOLECULESSACTION_HPP_
+#define CLEARALLMOLECULESSACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+#include "ClearAllMoleculesAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* CLEARALLMOLECULESSACTION_HPP_ */
Index: src/Actions/SelectionAction/MoleculeByFormulaAction.cpp
===================================================================
--- src/Actions/SelectionAction/MoleculeByFormulaAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/MoleculeByFormulaAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,83 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * MoleculeByFormulaAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Descriptors/MoleculeFormulaDescriptor.hpp"
+#include "molecule.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "Actions/SelectionAction/MoleculeByFormulaAction.hpp"
+
+// and construct the stuff
+#include "MoleculeByFormulaAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionMoleculeByFormulaAction::performCall() {
+  std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
+
+  // obtain information
+  getParametersfromValueStorage();
+
+  DoLog(1) && (Log() << Verbose(1) << "Selecting molecules with chemical formula " << params.formula << ":" << endl);
+  std::vector<molecule *> matchingMolecules = World::getInstance().getAllMolecules(MoleculeByFormula(params.formula));
+  for (std::vector<molecule *>::const_iterator iter = matchingMolecules.begin(); iter != matchingMolecules.end(); ++iter) {
+    DoLog(1) && (Log() << Verbose(1) << "\t" << (*iter)->getId() << ", " << (*iter)->getName() << "." << endl);
+  }
+  World::getInstance().selectAllMolecules(MoleculeByFormula(params.formula));
+  return Action::state_ptr(new SelectionMoleculeByFormulaState(selectedMolecules,params));
+}
+
+Action::state_ptr SelectionMoleculeByFormulaAction::performUndo(Action::state_ptr _state) {
+  SelectionMoleculeByFormulaState *state = assert_cast<SelectionMoleculeByFormulaState*>(_state.get());
+
+  World::getInstance().clearMoleculeSelection();
+  for(std::vector<molecule *>::iterator iter = state->selectedMolecules.begin(); iter != state->selectedMolecules.end(); ++iter)
+    World::getInstance().selectMolecule(*iter);
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr SelectionMoleculeByFormulaAction::performRedo(Action::state_ptr _state){
+  SelectionMoleculeByFormulaState *state = assert_cast<SelectionMoleculeByFormulaState*>(_state.get());
+
+  World::getInstance().selectAllMolecules(MoleculeByFormula(state->params.formula));
+
+  return Action::state_ptr(_state);
+}
+
+bool SelectionMoleculeByFormulaAction::canUndo() {
+  return true;
+}
+
+bool SelectionMoleculeByFormulaAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionMoleculeByFormulaAction::getName() {
+  return NAME;
+}
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/MoleculeByFormulaAction.def
===================================================================
--- src/Actions/SelectionAction/MoleculeByFormulaAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/MoleculeByFormulaAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * MoleculeByFormulaAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class molecule;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (SelectionMoleculeByFormulaAction::NAME)
+#define paramreferences (formula)
+
+#define statetypes (std::vector<molecule*>)
+#define statereferences (selectedMolecules)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME MoleculeByFormula
+#define TOKEN "select-molecule-by-formula"
+
Index: src/Actions/SelectionAction/MoleculeByFormulaAction.hpp
===================================================================
--- src/Actions/SelectionAction/MoleculeByFormulaAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/MoleculeByFormulaAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,16 @@
+/*
+ * MoleculeByFormulaAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef MOLECULEBYFORMULAACTION_HPP_
+#define MOLECULEBYFORMULAACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+#include "MoleculeByFormulaAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* MOLECULEBYFORMULAACTION_HPP_ */
Index: src/Actions/SelectionAction/MoleculeByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/MoleculeByIdAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/SelectionAction/MoleculeByIdAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * MoleculeByIdAction.cpp
@@ -6,11 +13,14 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/MoleculeByIdAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "molecule.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -20,50 +30,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/MoleculeByIdAction.hpp"
 
+// and construct the stuff
+#include "MoleculeByIdAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionMoleculeByIdAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionMoleculeByIdState : public ActionState {
-public:
-  SelectionMoleculeByIdState(molecule* _mol) :
-    mol(_mol)
-  {}
-  molecule* mol;
-};
-
-const char SelectionMoleculeByIdAction::NAME[] = "select-molecule-by-id";
-
-SelectionMoleculeByIdAction::SelectionMoleculeByIdAction() :
-  Action(NAME)
-{}
-
-SelectionMoleculeByIdAction::~SelectionMoleculeByIdAction()
-{}
-
-void SelectionMoleculeById(molecule *_mol) {
-  ValueStorage::getInstance().setCurrentValue(SelectionMoleculeByIdAction::NAME, _mol);
-  ActionRegistry::getInstance().getActionByName(SelectionMoleculeByIdAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* SelectionMoleculeByIdAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryMolecule(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionMoleculeByIdAction::performCall() {
-  molecule *mol = NULL;
-
-  ValueStorage::getInstance().queryCurrentValue(NAME, mol);
-
-  if (!World::getInstance().isSelected(mol)) {
-    DoLog(1) && (Log() << Verbose(1) << "Selecting molecule " << mol->name << endl);
-    World::getInstance().selectMolecule(mol);
-    return Action::state_ptr(new SelectionMoleculeByIdState(mol));
+  if (!World::getInstance().isSelected(params.mol)) {
+    DoLog(1) && (Log() << Verbose(1) << "Selecting molecule " << params.mol->name << endl);
+    World::getInstance().selectMolecule(params.mol);
+    return Action::state_ptr(new SelectionMoleculeByIdState(params));
   } else {
     return Action::success;
@@ -74,8 +52,8 @@
   SelectionMoleculeByIdState *state = assert_cast<SelectionMoleculeByIdState*>(_state.get());
 
-  if (state->mol != NULL)
-    World::getInstance().unselectMolecule(state->mol);
+  if (state->params.mol != NULL)
+    World::getInstance().unselectMolecule(state->params.mol);
 
-  return Action::state_ptr(new SelectionMoleculeByIdState(state->mol));
+  return Action::state_ptr(_state);
 }
 
@@ -83,8 +61,8 @@
   SelectionMoleculeByIdState *state = assert_cast<SelectionMoleculeByIdState*>(_state.get());
 
-  if (state->mol != NULL)
-    World::getInstance().selectMolecule(state->mol);
+  if (state->params.mol != NULL)
+    World::getInstance().selectMolecule(state->params.mol);
 
-  return Action::state_ptr(new SelectionMoleculeByIdState(state->mol));
+  return Action::state_ptr(state);
 }
 
@@ -100,2 +78,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/MoleculeByIdAction.def
===================================================================
--- src/Actions/SelectionAction/MoleculeByIdAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/MoleculeByIdAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * MoleculeByIdAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class molecule;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (molecule*)
+#define paramtokens (SelectionMoleculeByIdAction::NAME)
+#define paramreferences (mol)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME MoleculeById
+#define TOKEN "select-molecule-by-id"
+
Index: src/Actions/SelectionAction/MoleculeByIdAction.hpp
===================================================================
--- src/Actions/SelectionAction/MoleculeByIdAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/SelectionAction/MoleculeByIdAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,28 +11,6 @@
 #include "Actions/Action.hpp"
 
-class molecule;
-
-void SelectionMoleculeById(molecule *_mol);
-
-class SelectionMoleculeByIdAction : public Action {
-  friend void SelectionMoleculeById(molecule *_mol);
-
-public:
-  SelectionMoleculeByIdAction();
-  virtual ~SelectionMoleculeByIdAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "MoleculeByIdAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* MOLECULEBYIDACTION_HPP_ */
Index: src/Actions/SelectionAction/MoleculeOfAtomAction.cpp
===================================================================
--- src/Actions/SelectionAction/MoleculeOfAtomAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/MoleculeOfAtomAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,78 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * MoleculeOfAtomAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Descriptors/MoleculeDescriptor.hpp"
+#include "atom.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "Actions/SelectionAction/MoleculeOfAtomAction.hpp"
+
+// and construct the stuff
+#include "MoleculeOfAtomAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionMoleculeOfAtomAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
+
+  std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
+  DoLog(1) && (Log() << Verbose(1) << "Selecting molecule to which " << params.Walker->getName() << " belongs." << endl);
+  World::getInstance().selectMoleculeOfAtom(params.Walker);
+  return Action::state_ptr(new SelectionMoleculeOfAtomState(selectedMolecules, params));
+}
+
+Action::state_ptr SelectionMoleculeOfAtomAction::performUndo(Action::state_ptr _state) {
+  SelectionMoleculeOfAtomState *state = assert_cast<SelectionMoleculeOfAtomState*>(_state.get());
+
+  World::getInstance().clearMoleculeSelection();
+  for(std::vector<molecule *>::iterator iter = state->selectedMolecules.begin(); iter != state->selectedMolecules.end(); ++iter)
+    World::getInstance().selectMolecule(*iter);
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr SelectionMoleculeOfAtomAction::performRedo(Action::state_ptr _state){
+  SelectionMoleculeOfAtomState *state = assert_cast<SelectionMoleculeOfAtomState*>(_state.get());
+
+  World::getInstance().selectMoleculeOfAtom(state->params.Walker);
+
+  return Action::state_ptr(_state);
+}
+
+bool SelectionMoleculeOfAtomAction::canUndo() {
+  return true;
+}
+
+bool SelectionMoleculeOfAtomAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionMoleculeOfAtomAction::getName() {
+  return NAME;
+}
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/MoleculeOfAtomAction.def
===================================================================
--- src/Actions/SelectionAction/MoleculeOfAtomAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/MoleculeOfAtomAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,24 @@
+/*
+ * MoleculeOfAtomAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (atom*)
+#define paramtokens (SelectionMoleculeOfAtomAction::NAME)
+#define paramreferences (Walker)
+
+#define statetypes (std::vector<molecule*>)
+#define statereferences (selectedMolecules)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME MoleculeOfAtom
+#define TOKEN "select-molecule-of-atom"
+
Index: src/Actions/SelectionAction/MoleculeOfAtomAction.hpp
===================================================================
--- src/Actions/SelectionAction/MoleculeOfAtomAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/MoleculeOfAtomAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,16 @@
+/*
+ * MoleculeOfAtomAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef MOLECULEOFATOMSACTION_HPP_
+#define MOLECULEOFATOMSACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+#include "MoleculeOfAtomAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* MOLECULEOFATOMSACTION_HPP_ */
Index: src/Actions/SelectionAction/NotAllAtomsAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/SelectionAction/NotAllAtomsAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * NotAllAtomsAction.cpp
@@ -6,12 +13,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/NotAllAtomsAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "atom.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -21,49 +31,22 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/NotAllAtomsAction.hpp"
 
+// and construct the stuff
+#include "NotAllAtomsAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionNotAllAtomsAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionAllAtomsState : public ActionState {
-public:
-  SelectionAllAtomsState(std::vector<atom*> _selectedAtoms) :
-    selectedAtoms(_selectedAtoms)
-  {}
-  std::vector<atom*> selectedAtoms;
-};
-
-const char SelectionNotAllAtomsAction::NAME[] = "unselect-all-atoms";
-
-SelectionNotAllAtomsAction::SelectionNotAllAtomsAction() :
-  Action(NAME)
-{}
-
-SelectionNotAllAtomsAction::~SelectionNotAllAtomsAction()
-{}
-
-void SelectionNotAllAtoms() {
-  ActionRegistry::getInstance().getActionByName(SelectionNotAllAtomsAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* SelectionNotAllAtomsAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionNotAllAtomsAction::performCall() {
   std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
   DoLog(1) && (Log() << Verbose(1) << "Unselecting all atoms." << endl);
   World::getInstance().clearAtomSelection();
-  return Action::state_ptr(new SelectionAllAtomsState(selectedAtoms));
+  return Action::state_ptr(new SelectionNotAllAtomsState(selectedAtoms, params));
 }
 
 Action::state_ptr SelectionNotAllAtomsAction::performUndo(Action::state_ptr _state) {
-  SelectionAllAtomsState *state = assert_cast<SelectionAllAtomsState*>(_state.get());
+  SelectionNotAllAtomsState *state = assert_cast<SelectionNotAllAtomsState*>(_state.get());
 
   World::getInstance().clearAtomSelection();
@@ -71,13 +54,13 @@
     World::getInstance().selectAtom(*iter);
 
-  return Action::state_ptr(new SelectionAllAtomsState(state->selectedAtoms));
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr SelectionNotAllAtomsAction::performRedo(Action::state_ptr _state){
-  SelectionAllAtomsState *state = assert_cast<SelectionAllAtomsState*>(_state.get());
+  //SelectionNotAllAtomsState *state = assert_cast<SelectionNotAllAtomsState*>(_state.get());
 
   World::getInstance().clearAtomSelection();
 
-  return Action::state_ptr(new SelectionAllAtomsState(state->selectedAtoms));
+  return Action::state_ptr(_state);
 }
 
@@ -93,2 +76,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotAllAtomsAction.def
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/NotAllAtomsAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * NotAllAtomsAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotAllAtoms
+#define TOKEN "unselect-all-atoms"
+
Index: src/Actions/SelectionAction/NotAllAtomsAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/SelectionAction/NotAllAtomsAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,26 +11,6 @@
 #include "Actions/Action.hpp"
 
-void SelectionNotAllAtoms();
-
-class SelectionNotAllAtomsAction : public Action {
-  friend void SelectionNotAllAtoms();
-
-public:
-  SelectionNotAllAtomsAction();
-  virtual ~SelectionNotAllAtomsAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "NotAllAtomsAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* NOTALLATOMSACTION_HPP_ */
